import {
    BrowserModule
} from '@angular/platform-browser';
import {
    FormsModule
} from '@angular/forms';
import {
    HttpModule
} from '@angular/http';
import {
    NgModule,
    ApplicationRef
} from '@angular/core';
import {
    removeNgStyles,
    createNewHosts,
    createInputTransfer
} from '@angularclass/hmr';
import {
    RouterModule,
    PreloadAllModules
} from '@angular/router';

import {
    ENV_PROVIDERS
} from './environment';
// App is our top level component
import {
    IndexComponent
} from './pages/index';

{{$importTemplateComponent$}}

{{$importTemplateService$}}

interface StoreType {
    restoreInputValues: () => void;
    disposeOldHosts: () => void;
}
/**
 * `AppModule` is the main entry point into Angular2's bootstraping process
 */
@NgModule({
    bootstrap: [IndexComponent],
    declarations: [
        IndexComponent,
        {{$TemplateComponent$}}
    ],
    /**
     * Import Angular's modules.
     */
    imports: [
        BrowserModule,
        FormsModule,
        HttpModule
    ],
    /**
     * Expose our Services and Providers into Angular's dependency injection.
     */
    providers: [
        ENV_PROVIDERS,
        {{$TemplateService$}}
    ]
})
export class AppModule {

    constructor(
        public appRef: ApplicationRef,
        {{$TemplateInjectService$}}
    ) {}

    public hmrOnInit(store: StoreType) {
    }

    public hmrOnDestroy(store: StoreType) {
        const cmpLocation = this.appRef.components.map((cmp) => cmp.location.nativeElement);
        store.disposeOldHosts = createNewHosts(cmpLocation);
        removeNgStyles();
    }

    public hmrAfterDestroy(store: StoreType) {
        store.disposeOldHosts();
        delete store.disposeOldHosts;
    }

}