import {
    BrowserModule
} from '@angular/platform-browser';
import {
    BrowserAnimationsModule
} from '@angular/platform-browser/animations';
import {
    NgModule
} from '@angular/core';
import { FormsModule } from '@angular/forms';
import {
    CommonModule
} from '@angular/common';
import {
    HttpModule
} from '@angular/http';
import {
    MobxAngularModule
} from 'mobx-angular';
import {
    ButtonModule
} from 'jpush-ui/button';
import {
    InputModule
} from 'jpush-ui/input';

import {
    IndexComponent
} from './components/index';
import {
    ContentComponent
} from './components/content';

import {
    MobxStore
} from './mobx';


@NgModule({
    declarations: [
        IndexComponent,
        ContentComponent
    ],
    imports: [
        BrowserModule,
        CommonModule,
        HttpModule,
        BrowserAnimationsModule,
        FormsModule,
        InputModule,
        MobxAngularModule,
        ButtonModule
    ],
    bootstrap: [IndexComponent],
    providers:[MobxStore]
})
export class AppModule {}