import {
    Component,
    OnInit,
    OnChanges,
    OnDestroy
} from '@angular/core';
import {
    Store
} from '@ngrx/store';
import 'rxjs/add/operator/filter';
@Component({
    selector: 'content-component',
    templateUrl: './content.component.html',
    styleUrls: ['./content.component.css']
})
export class ContentComponent implements OnInit {
    public stream: any;
    public list:any[] = [];
    constructor(
        public store$: Store < any >
    ) {
        /*  */
    }
    public ngOnInit() {
        /*  */
        this.stream = this.store$.select('NgrxReducer')
            .filter(data => {
                return data&&data.list;
            }).subscribe((data:any) => {
                this.list = data.list;
            }, (error) => {
                console.log(error);
            });
    }
    public ngOnDestroy() {
        if (this.stream) {
            this.stream.unsubscribe();
        }
    }
    public delete(start){
        this.store$.dispatch({
            type:'[Delete] Data General',
            payload:{
                start:start
            }
        })
    }
}