const gulp = require('gulp');
const glob = require('glob');
const gutil = require("gulp-util");
const webpack = require('webpack');
const colors = require('colors');
const config = require('../config.json');
const env = config[process.argv[2]] ? process.argv[2] : 'dev';
let tags = getEntries('src/pages/**/main.browser.ts');
let type = 's';
if (process.argv.indexOf('-t') > -1 && process.argv.indexOf('m') > -1) {
    type = 'm';
    onsole.log(colors.yellow.underline('进入并发模式build模式，如果报错请使用默认模式！'));
}

if (process.argv.indexOf('-p') > -1) {
    if (process.argv[4] && tags.indexOf(process.argv[4]) > -1) {
        console.log(colors.yellow.underline('进入单任务模式，build ' + process.argv[4] + '页面！'));
        tags = [process.argv[4]];
    } else {
        console.log(colors.red.underline('进入单任务模式失败，不存在' + process.argv[4] + '页面！'));
    }
} else {
    console.log(colors.yellow.underline('进入多任务模式，任务数 ' + tags.length + '个'));
}

function getEntries(globPath) {
    const files = glob.sync(globPath),
        tags = [];
    files.forEach(function (filepath) {
        // 取倒数第二层(view下面的文件夹)做包名
        const split = filepath.split('/');
        const tag = split[split.length - 2];
        tags.push(tag)
    });
    return tags;
}
gulp.task('build', function (callback) {
    let index = 0;
    if (type == 'm') {
        tags.forEach((tag, i) => {
            console.log(colors.yellow.underline('开始执行第' + (i + 1) + '个build任务：' + tag));
            const webpackConfig = require('../webpack/webpack.prod')(env, tag);
            webpack(webpackConfig, function (err, stats) {
                if (err) throw new gutil.PluginError("webpack", err);
                gutil.log("[webpack]", stats.toString({
                    colors: true
                }));
                index = index + 1;
                console.log(colors.green('已完成build ' + tag + '页面任务!'));
                if (index == tags.length) {
                    callback();
                }
            })
        });
    } else {
        const build = (i, pagenames, cb) => {
            const webpackConfig = require('../webpack/webpack.prod')(env, pagenames[i]);
            console.log(colors.yellow.underline('开始执行第' + (i + 1) + '个build任务：' + pagenames[i]));
            webpack(webpackConfig, (err, stats) => {
                if (err) throw new gutil.PluginError("webpack", err);
                gutil.log("[webpack]", stats.toString({
                    colors: true
                }));
                i = i + 1;
                console.log(colors.green('已完成build ' + pagenames[i - 1] + '页面任务!'));
                if (i === pagenames.length) {
                    callback();
                } else {
                    build(i, pagenames);
                }
            })
        };
        build(index, tags);
    }
})