/* 
组件依赖服务TemplateService
TemplateService 提供了method方法
@input input
@output output
method get
event buttonclick
*/

import {
    DebugElement,
    Component,
    ViewChild
} from "@angular/core";
import {
    HttpModule,
    XHRBackend
} from '@angular/http';
import {
    TestBed,
    ComponentFixture,
    tick,
    fakeAsync,
    inject,
    async
} from '@angular/core/testing';
import {
    By
} from '@angular/platform-browser';

import {
    {{$Template$}}Service
} from './{{%template%}}.service'; //依赖服务
import {
    {{$Template$}}Component
} from "./{{%template%}}.component"; //测试组件

@Component({
    template: `<{{%template%}}-componet [input]="input" (output)="output()"></{{%template%}}-componet>`
})

/* 创建test组件 */
class TestComponent {
    @ViewChild({{$Template$}}Component) comp: {
        {
            $Template$
        }
    }
    Component;
    input: number = 0;
    output() {}
}

describe('Component: {{$Template$}}Component', () => {
    let fixture: ComponentFixture < TestComponent > ,
        context: TestComponent,
        el: HTMLElement,
        de: DebugElement;

    describe('with spy of service', () => {
        let spy: jasmine.Spy;
        const res = {
            "id": 10000,
            "user_id": 1,
            "user_name": "asdf",
            "sku_id": 10000,
            "title": "商品名称"
        };

        beforeEach(() => {
            TestBed.configureTestingModule({
                imports: [HttpModule],
                declarations: [
                    {{$Template$}}Component, TestComponent
                ],
                providers: [{{$Template$}}Service]
            });
            fixture = TestBed.createComponent(TestComponent);
            context = fixture.componentInstance;
            el = fixture.nativeElement;
            de = fixture.debugElement;

            /* 注入依赖 */
            // let injectService = fixture.debugElement.injector.get({{$Template$}}Service)
            /* 监听事件 */
            spyOn(context, 'output');
            // spy = spyOn(injectService, 'method').and.returnValue(Promise.resolve(res));
        });

        it('非异步', () => {
            // context.input = 1; //input赋值
            // fixture.detectChanges(); //手动检查更新
            // expect(el.querySelector('h1').innerText).toBe('trade 1');
            // expect(spy.calls.any()).toBe(true, 'get called');
        });
        it('异步测试一', async(() => {
            // fixture.detectChanges();
            // fixture.whenStable().then(() => {
            //     fixture.detectChanges();
            //     expect(context.comp.item.id).toBe(res.id);
            //     expect(el.querySelector('dl')).not.toBeNull();
            //     expect(el.querySelector('.sku-id').textContent).toBe('' + res.sku_id);
            //     expect(el.querySelector('.ware-title').textContent).toBe(res.title);
            // });
        }));

        it('异步测试二', fakeAsync(() => {
            // fixture.detectChanges();
            // tick(); //等待异步完成
            // fixture.detectChanges();
            // expect(context.comp.item.id).toBe(res.id);
            // expect(el.querySelector('dl')).not.toBeNull();
            // expect(el.querySelector('.sku-id').textContent).toBe('' + res.sku_id);
            // expect(el.querySelector('.ware-title').textContent).toBe(res.title);
        }));

        it('test buttonclick', () => {
            // el.querySelector('button').click(); //触发dom元素 click事件
            // fixture.detectChanges();
            // expect(context.output).toHaveBeenCalled();
        });
    });
});