const colors = require('colors');
const path = require('path');
const FileAction = require('./file');
module.exports = function (config) {
	if (config.init) {
		// 初始化项目复制
		const src = path.resolve(__dirname, '../lib/init/spa-seed');
		FileAction.exists(src, config.path, false, FileAction.copy);
		return null;
	}
	if (config.mpa) {
		// 初始化项目复制
		const src = path.resolve(__dirname, '../lib/init/mpa-seed');
		FileAction.exists(src, config.path, false, FileAction.copy);
		return null;
	}
	let src = path.resolve(__dirname, '../lib/component');
	switch (config.type) {
		case 'm':
			src = path.resolve(__dirname, '../lib/module');
			break;
		case 'd':
			src = path.resolve(__dirname, '../lib/directive');
			break;
		case 'p':
			src = path.resolve(__dirname, '../lib/pipe');
			break;
		case 'n':
			config.name = config.name.toUpperCase();
			config.path = config.path + '/ngrx';
			src = path.resolve(__dirname, '../lib/ngrx');
		case 'a':
			config.name = config.name.toUpperCase();
			src = path.resolve(__dirname, '../lib/action');
			break;
		case 's':
			src = path.resolve(__dirname, '../lib/mobk');
			break;
		case 'spec-c':
			src = path.resolve(__dirname, '../lib/test/component');
			break;
		case 'spec-s':
			src = path.resolve(__dirname, '../lib/test/service');
			break;
		case 'spec-p':
			src = path.resolve(__dirname, '../lib/test/pipe');
			break;
		case 'spec-d':
			src = path.resolve(__dirname, '../lib/test/directive');
			break;
		default:
			path.resolve(__dirname, '../lib/component');
	}

	FileAction.exists(src, config.path, config, FileAction.copy);
}